//########## Bonecrusher

//### Sounds

datablock AudioProfile(gc_BonecrusherFireSound)
{
  filename = "./bonecrusher.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_BonecrusherReloadSound)
{
  filename = "./bonecrusherreload.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_BonecrusherHitSound)
{
  filename = "./bonecrusherhit.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_BonecrusherFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 0 1";
  colors[1] = "1 1 0 1";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.2;
  sizes[1] = 2.5;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_BonecrusherFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BonecrusherFlashParticle";
};

datablock ParticleData(gc_BonecrusherTrailParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 200;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 1 0 0.5";
  colors[1] = "1 0.5 0 0";
  sizes[0] = 1.5;
  sizes[1] = 0.2;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_BonecrusherTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BonecrusherTrailParticle";
};

datablock ParticleData(gc_BonecrusherSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "1 1 0 1";
  colors[1] = "1 1 0 0.5";
  colors[2] = "1 0 0 0";
  sizes[0] = 4;
  sizes[1] = 1;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_BonecrusherSmokeEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_BonecrusherSmokeParticle";
};

datablock ExplosionData(gc_BonecrusherExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_BonecrusherSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
  soundProfile = gc_BonecrusherHitSound;
};

datablock DebrisData(gc_BonecrusherShellDebris)
{
  shapeFile = "./shell.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

//### Projectile

AddDamageType("gc_Bonecrusher",'<bitmap:Add-ons/Weapon_Bonecrusher/CI_bonecrusher> %1','%2 <bitmap:Add-ons/Weapon_Bonecrusher/CI_bonecrusher> %1',0.2,1);

datablock ProjectileData(gc_BonecrusherProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 10;
  directDamageType = $DamageType::gc_Bonecrusher;
  radiusDamageType = $DamageType::gc_Bonecrusher;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 12;
  brickExplosionMaxVolumeFloating = 12;
  impactImpulse = 1500;
  verticalImpulse = 100;
  explosion = gc_BonecrusherExplosion;
  particleEmitter = gc_BonecrusherTrailEmitter;
  muzzleVelocity = 150;
  verInheritFactor = 1;
  lifetime = 2000;
  fadeDelay = 1000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
};

//### Item

datablock ItemData(gc_BonecrusherItem)
{
  uiName = "Bonecrusher";
  iconName = "./icon_bonecrusher";
  image = gc_BonecrusherImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./bonecrusher.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_BonecrusherImage)
{
  shapeFile = "./bonecrusher.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_bonecrusherItem;
  ammo = "";
  projectile = gc_BonecrusherProjectile;
  projectileType = Projectile;
  casing = gc_BonecrusherShellDebris;
  shellExitDir = "1 0 0.5";
  shellExitVariance = 10;
  shellVelocity = 8;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Reload";

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateTransitionOnNoAmmo[1] = "Reload";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Reload";
  stateTimeoutValue[2] = "0.25";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_BonecrusherFlashEmitter;
  stateSound[2] = gc_BonecrusherFireSound;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateScript[2] = "onFire";
  stateSequence[2] = "Fire";

  stateName[3] = "Reload";
  stateTimeoutValue[3] = "0.35";
  stateTransitionOnTimeout[3] = "Wait";
  stateSequence[3] = "Reload";
  stateSound[3] = gc_BonecrusherReloadSound;
  stateEjectShell[3] = true;

  stateName[4] = "Wait";
  stateTransitionOnTriggerUp[4] = "Ready";
};

function gc_BonecrusherImage::onFire(%this,%obj,%slot)
{
  %spread = 0.0025;
  for(%i=0;%i<8;%i++)
  {
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %p = new Projectile()
    {
      dataBlock = %this.projectile;
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity));
      initialPosition = %obj.getMuzzlePoint(0);
      sourceObject = %obj;
      sourceSlot = 0;
      client = %obj.client;
    };
  }
  MissionCleanup.add(%p);
}
